package de.mdelab.instanceGraphEditor.ui.commands;

import org.eclipse.gef.commands.Command;

import de.mdelab.instanceGraphEditor.ui.model.Link;
import de.mdelab.instanceGraphEditor.ui.model.Graph;
import de.mdelab.instanceGraphEditor.ui.model.Node;

public class ConnectionCreateCommand extends Command{

	private Node source;
	private Node target;
	private Link connection;
	private Graph graph;

	public void setSource(Node source) {
		this.source = source;
	}

	public void setTarget(Node target) {
		this.target = target;
	}
	
	  public void setGraph(Graph graph) {
		    this.graph = graph;
		  }

	public void setConnection(Link connection) {
		this.connection = connection;
	}

	public boolean canExecute() {
		return source != null && target != null;
	}

	public void execute() {
		connection.setSource(source);
		connection.setTarget(target);
		
		
	}

	public void undo() {
		connection.setSource(null);
		connection.setTarget(null);
	}

}
