package de.mdelab.instanceGraphEditor.ui.parts;

import org.eclipse.draw2d.Connection;
import org.eclipse.draw2d.RelativeBendpoint;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.NodeEditPart;


public class BorderRelativeBendpoint extends RelativeBendpoint {
	
	
    enum Side { RIGHT_MIDDLE , RIGHT_BOTTOM , BOTTOM_MIDDLE   }
    
    
	SelfLinkEditPart selfConnectionEditPart;
	
	Side type;
	
	//relative to the figure's border offset.
	int x,y;
	
	public BorderRelativeBendpoint() {
	
	}
	
	public BorderRelativeBendpoint(Connection conn, SelfLinkEditPart selfConnectionEditPart, int x, int y, Side type) {
		
		
		setConnection(conn);
		this.selfConnectionEditPart = selfConnectionEditPart;
		this.x = x;
		this.y = y;
		this.type = type;
	}
	
	@Override
	public Point getLocation() {

		switch (type) {
		case RIGHT_MIDDLE:
		{
			int x = ((NodeEditPart)selfConnectionEditPart.getSource()).getFigure().getBounds().x +  ((NodeEditPart)selfConnectionEditPart.getSource()).getFigure().getBounds().width;
			int y = ((NodeEditPart)selfConnectionEditPart.getSource()).getFigure().getBounds().y +  ((NodeEditPart)selfConnectionEditPart.getSource()).getFigure().getBounds().height/2;
			return new Point( x + this.x, y + this.y);
		}
		case RIGHT_BOTTOM:
		{
			int x = ((NodeEditPart)selfConnectionEditPart.getSource()).getFigure().getBounds().x +  ((NodeEditPart)selfConnectionEditPart.getSource()).getFigure().getBounds().width;
			int y = ((NodeEditPart)selfConnectionEditPart.getSource()).getFigure().getBounds().y +  ((NodeEditPart)selfConnectionEditPart.getSource()).getFigure().getBounds().height;
			return new Point( x + this.x, y + this.y);
		}
		
		case BOTTOM_MIDDLE:
		{
			int x = ((NodeEditPart)selfConnectionEditPart.getSource()).getFigure().getBounds().x +  ((NodeEditPart)selfConnectionEditPart.getSource()).getFigure().getBounds().width/2;
			int y = ((NodeEditPart)selfConnectionEditPart.getSource()).getFigure().getBounds().y +  ((NodeEditPart)selfConnectionEditPart.getSource()).getFigure().getBounds().height;
			return new Point( x + this.x, y + this.y);
		}


		default:
			return new Point(0,0);
		}
	}

}
