package de.mdelab.resourceSetSynchronizer;

import java.io.IOException;
import java.net.ServerSocket;

public class ConnectionUtil {
	
	public static final long DEFAULT_CONNECTION_TIMEOUT = 30000;
	
	private ConnectionUtil() {
	}

	public static Integer findNextAvailablePort( final int startPort ) {
		int port = startPort + 1;

		while ( port < Integer.MAX_VALUE ) {
			try	{
				final ServerSocket serverSocket = new ServerSocket( port );
				serverSocket.close();
				
				System.out.println( "Found open port " + port + "." );

				return port;
			}
			catch ( final IOException e )	{
				port++;
			}
		}

		return null;
	}
}
