package de.mdelab.sdm.interpreter.core.debug;

import java.util.Map;

import de.mdelab.expressions.interpreter.core.variables.Variable;
import de.mdelab.sdm.interpreter.core.executionTrace.ExecutionTrace;

public abstract class SDExecution<CoverageReport, Classifier> {

	private final ExecutionTrace executionTrace;

	private final CoverageReport coverageReport;
	
	private final  Map<String, Variable<Classifier>> returnVariables;
	
	public SDExecution( 	final ExecutionTrace p_executionTrace,
							final CoverageReport p_coverageReport,
							final Map<String, Variable<Classifier>> p_returnVariables ) {
		executionTrace = p_executionTrace;
		coverageReport = p_coverageReport;
		returnVariables = p_returnVariables;
	}

	public ExecutionTrace getExecutionTrace() {
		return executionTrace;
	}

	public CoverageReport getCoverageReport() {
		return coverageReport;
	}

	public Map<String, Variable<Classifier>> getReturnVariables() {
		return returnVariables;
	}
}
