package de.mdelab.sdm.interpreter.core.debug.client.protocol.indications;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.net4j.signal.IndicationWithResponse;
import org.eclipse.net4j.signal.SignalProtocol;
import org.eclipse.net4j.util.io.ExtendedDataInputStream;
import org.eclipse.net4j.util.io.ExtendedDataOutputStream;

import de.mdelab.sdm.interpreter.core.debug.client.ExecutionResumedEvent;
import de.mdelab.sdm.interpreter.core.debug.client.SDDebugClient;
import de.mdelab.sdm.interpreter.core.debug.protocol.SDDebugProtocolEventMessagesEnum;

/**
 * @author DB
 * 
 *	We need respond from the client to ensure the resume event is always processed by the client before the following 
 *  suspend event.
* @param <StoryDiagramElement>
 */
public class ExecutionResumedEventIndication<StoryDiagramElement extends EObject> extends IndicationWithResponse {//SDDebugProtocolEventIndication<StoryDiagramElement> {
	
	private final SDDebugClient<StoryDiagramElement, ?> debugClient;

	public ExecutionResumedEventIndication(	final SignalProtocol<?> p_protocol,
											final SDDebugClient<StoryDiagramElement, ?> p_debugClient )	{
		super( p_protocol, SDDebugProtocolEventMessagesEnum.EXECUTION_RESUMED );
		
		debugClient = p_debugClient;
	}

	@Override
	protected void indicating(ExtendedDataInputStream in)
	throws Exception {
		final ExecutionResumedEvent event = new ExecutionResumedEvent();
		debugClient.getDebugEventQueue().put( event );
	}

	@Override
	protected void responding(ExtendedDataOutputStream out)
	throws Exception {
		out.writeObject( true );
	}
}
