package de.mdelab.sdm.interpreter.core.debug.protocol.requests;

import org.eclipse.net4j.signal.RemoteException;
import org.eclipse.net4j.signal.RequestWithConfirmation;
import org.eclipse.net4j.signal.SignalProtocol;
import org.eclipse.net4j.util.io.ExtendedDataInputStream;
import org.eclipse.net4j.util.io.ExtendedDataOutputStream;

import de.mdelab.resourceSetSynchronizer.ConnectionUtil;
import de.mdelab.sdm.interpreter.core.debug.protocol.SDDebugProtocolEventMessagesEnum;

/**
 * @author DB
 *	We need this to require confirmation from the client to ensure it is always processed by the client before the following 
 *  suspend event.
 */
public class ExecutionResumedEventRequest extends RequestWithConfirmation<Boolean> { //SDEDebugProtocolEventRequest

	public ExecutionResumedEventRequest( final SignalProtocol<?> p_protocol ) {
		super( p_protocol, SDDebugProtocolEventMessagesEnum.EXECUTION_RESUMED );
	}

	@Override
	protected void requesting(final ExtendedDataOutputStream p_out )
	throws Exception {
		// Do nothing
	}

	@Override
	protected Boolean confirming( final ExtendedDataInputStream p_in )
	throws Exception {
		return (Boolean) p_in.readObject( getClass().getClassLoader() );
	}
	

    /* DB: Overridden to use a longer default timeout for requests
     * 
     * (non-Javadoc)
     * @see org.eclipse.net4j.signal.RequestWithConfirmation#send()
     */
    @Override
    public Boolean send() 
    throws Exception, RemoteException {
    	return super.send( ConnectionUtil.DEFAULT_CONNECTION_TIMEOUT );
    }
}
